#!/bin/bash

supported_types=("ASCII text executable" "ELF 64-bit LSB")
unsupported_types="ELF 64-bit LSB shared object"
args=("--help" "-h" "-v" "--info")
commond_path="/root/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin"

sqlite3 ocs23.sqlite "CREATE TABLE command (
        command_id INTEGER NOT NULL, 
        command VARCHAR, 
        pkgId VARCHAR,
        argList TEXT,
        PRIMARY KEY (command_id), 
        UNIQUE (command_id)
);"

rpm -qa | while read package; do
    echo "package $package"
    rpm -ql "$package" | while read file; do
        if echo "$file" | grep "\.debug$"; then
            continue
        fi

        file_type=$(file -b "$file")
        supported_type=0
        for t in "${supported_types[@]}"; do
            if echo "$file_type" | grep -w "$t" | grep -E -v "$unsupported_types"; then
                supported_type=1
                break
            fi
        done
        if [ "$supported_type" -eq 1 ]; then
            echo "command $file"
            for arg in "${args[@]}"; do
               argList=$(eval "$file $arg" 2>&1)
               if [ $? -ne 0 ]; then
                   echo "$file $arg failed"
                   continue  # Skip to the next argument
               fi
                sqlite3 ocs23.sqlite "INSERT INTO command (command, pkgId, argList) VALUES ('$file', '$package', '$argList');"
                break
            done
        fi
    done
done
