#!/bin/bash

# 变量
db_name="ocs23.sqlite"

# 创建 filelist 表
sqlite3 "$db_name" "CREATE TABLE filelist (
        pkgKey INTEGER,
        filenames TEXT,
        filetypes TEXT
);"

# 在数据库中查询包名及其对应的 pkgKey
pkg_keys_and_names=$(sqlite3 "$db_name" "SELECT pkgKey, pkgname FROM packages;")

# 遍历所有包及其 pkgKey
while IFS='|' read -ra row; do
    pkgKey="${row[0]}"
    pkg_name="${row[1]}"

    # 查找包内的所有文件
    rpm_files=$(rpm -ql "$pkg_name")

    # 遍历包内的每个文件并记录其文件类型
    for rpm_file in $rpm_files; do
        if [ -d "$rpm_file" ]; then
            file_type="d"
        elif [ -f "$rpm_file" ]; then
            file_type="f"
        else
            file_type=""
        fi

        # 如果找到一个文件类型，将文件名和文件类型插入到 filelist 表中
        if [ ! -z "$file_type" ]; then
            sqlite3 "$db_name" "INSERT INTO filelist (pkgKey, filenames, filetypes) VALUES ($pkgKey, '$rpm_file', '$file_type');"
        fi

    done
done <<<"$pkg_keys_and_names"
