#!/bin/bash

# 变量
db_name="ocs23.sqlite"

# 在数据库中创建 packages 表
sqlite3 "$db_name" "CREATE TABLE packages (
        pkgKey INTEGER PRIMARY KEY,
        pkgname TEXT,
        version TEXT,
        release TEXT
);"

# 遍历所有安装的 rpm 包
rpm -qa --queryformat '%{NAME}|%{VERSION}|%{RELEASE}\n' | while IFS='|' read -ra row; do
    pkg_name="${row[0]}"
    version="${row[1]}"
    release="${row[2]}"
    # 将 rpm 包的详细信息插入到 packages 表中
    sqlite3 "$db_name" "INSERT INTO packages (pkgname, version, release) VALUES ('$pkg_name', '$version', '$release');"
done

# 创建触发器
sqlite3 "$db_name" "CREATE TRIGGER remove_filelist AFTER DELETE ON packages
                   BEGIN
                     DELETE FROM filelist WHERE pkgKey = old.pkgKey;
                   END;"

# 创建索引
sqlite3 "$db_name" "CREATE INDEX pkgKey ON packages (pkgKey);"
